package com.apelon.modules.dts.editor.tableviewer;

import java.awt.dnd.DnDConstants;
import java.awt.dnd.DropTarget;
import java.awt.dnd.DropTargetDragEvent;
import java.awt.dnd.DropTargetDropEvent;
import java.awt.dnd.DropTargetEvent;
import java.awt.dnd.DropTargetListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import javax.swing.JButton;
 
/**
 * JButton used as a "well" for dropping, dropping fires button clicked event.
 * <p>
 * Copyright (c) 2006 Apelon, Inc. All rights reserved.
 * @since 3.4.0
 */
public class DropButton extends JButton implements DropTargetListener
{
 
    public DropButton(String label)
    {
        super(label);
        addMouseListener(new MouseHandler());
        dropTarget = new DropTarget(this, DnDConstants.ACTION_MOVE, this, true);
    }
        
    public DropTargetDropEvent getDropEvent()
    {
        return dropEvent;
    }
        

    /** handle mouse press to clear event */
    private class MouseHandler extends MouseAdapter 
    {
        public void mousePressed(MouseEvent me) 
        {
            dropEvent = null;
        }
    }
        

    private DropTarget dropTarget;
    private DropTargetDropEvent dropEvent = null;
        
    /** DropTargetListener interface */
    public void dragEnter(DropTargetDragEvent de)
    {
        de.acceptDrag(DnDConstants.ACTION_MOVE);
        setSelected(true);
    }
        
    public void drop(DropTargetDropEvent de)
    {
        dropEvent = de;
        setSelected(false);
        doClick();                              //fire an event
        de.dropComplete(true);
    }
        
        
    public void dragOver(DropTargetDragEvent de) { }
        
    public void dragExit(DropTargetEvent de) 
    {
        setSelected(false);
    }
        
    public void dropActionChanged(DropTargetDragEvent de) {}
} 