package com.apelon.modules.dts.editor.tableviewer;

 
/**
 * interface for panels that drive table panel
 * <p>
 * Copyright (c) 2006 Apelon, Inc. All rights reserved.
 * @since 3.4.0
 */
interface TableViewerTableDirector 
{
	/** get name/label of director */
	String getDirectorLabel();
	
	/** get the active function: LOAD/OPEN */
	int getActiveFunction();
	
	/** get the active name */
	String getActiveName();
	
	/** get the namespace id of the active name */
	int getActiveNamespaceId();
	
    /** called when Delete Concepts button is pressed */
    void deleteConcepts(int[] rows);

    /** called when New Concept button is pressed */
    void newConcept();
        
    /** called when Remove Rows button is pressed */
    void removeRows(int[] rows);
        
    /** called when drop/add rows button is pressed */
    void addRows(Object obj);
    
    /** called when clear button is pressed */
    void clear();
}
